<?php // $Id: view.php,v 1.106.2.5 2008/12/17 12:40:09 sam_marshall Exp $
/*
* Schnittstelle Moodle-Adobe Connect
* 
* @copyright eLearning @ Fachhochschule Lbeck
* @author oncampus support@oncampus.de
* @version 1.0
* 
* dieses Beispiel darf frei verwendet werden mit Hinweis auf den Urheber
* der Einsatz dieser Software besteht auf eigene Gefahr
* die FH Lbeck haftet fr keine Schaeden
*/


//  Display the course home page.

    require_once('../../config.php');
    require_once($CFG->dirroot.'/course/lib.php');
    require_once($CFG->libdir.'/blocklib.php');
    require_once($CFG->libdir.'/ajax/ajaxlib.php');
    require_once($CFG->dirroot.'/mod/forum/lib.php');
    require_once($CFG->dirroot.'/blocks/webkonf/lib.php');
	require_once($CFG->dirroot.'/AC/acoclib.php');

    $id          = optional_param('id', 0, PARAM_INT);
    $name        = optional_param('name', '', PARAM_RAW);
    $edit        = optional_param('edit', -1, PARAM_BOOL);
    $hide        = optional_param('hide', 0, PARAM_INT);
    $show        = optional_param('show', 0, PARAM_INT);
    $idnumber    = optional_param('idnumber', '', PARAM_RAW);
    $section     = optional_param('section', 0, PARAM_INT);
    $move        = optional_param('move', 0, PARAM_INT);
    $marker      = optional_param('marker',-1 , PARAM_INT);
    $switchrole  = optional_param('switchrole',-1, PARAM_INT);



    if (empty($id) && empty($name) && empty($idnumber)) {
        error("Must specify course id, short name or idnumber");
    }

    if (!empty($name)) {
        if (! ($course = get_record('course', 'shortname', $name)) ) {
            error('Invalid short course name');
        }
    } else if (!empty($idnumber)) {
        if (! ($course = get_record('course', 'idnumber', $idnumber)) ) {
            error('Invalid course idnumber');
        }
    } else {
        if (! ($course = get_record('course', 'id', $id)) ) {
            error('Invalid course id');
        }
    }

    preload_course_contexts($course->id);
    if (!$context = get_context_instance(CONTEXT_COURSE, $course->id)) {
        print_error('nocontext');
    }

    // Remove any switched roles before checking login
    if ($switchrole == 0 && confirm_sesskey()) {
        role_switch($switchrole, $context);
    }

    require_login($course);

    // Switchrole - sanity check in cost-order...
    $reset_user_allowed_editing = false;
    if ($switchrole > 0 && confirm_sesskey() &&
        has_capability('moodle/role:switchroles', $context)) {
        // is this role assignable in this context?
        // inquiring minds want to know...
        $aroles = get_assignable_roles_for_switchrole($context);
        if (is_array($aroles) && isset($aroles[$switchrole])) {
            role_switch($switchrole, $context);
            // Double check that this role is allowed here
            require_login($course->id);
        }
        // reset course page state - this prevents some weird problems ;-)
        $USER->activitycopy = false;
        $USER->activitycopycourse = NULL;
        unset($USER->activitycopyname);
        unset($SESSION->modform);
        $USER->editing = 0;
        $reset_user_allowed_editing = true;
    }

    //If course is hosted on an external server, redirect to corresponding
    //url with appropriate authentication attached as parameter 
    if (file_exists($CFG->dirroot .'/course/externservercourse.php')) {
        include $CFG->dirroot .'/course/externservercourse.php';
        if (function_exists('extern_server_course')) {
            if ($extern_url = extern_server_course($course)) {
                redirect($extern_url);
            }
        }
    }


    require_once($CFG->dirroot.'/calendar/lib.php');    /// This is after login because it needs $USER

    add_to_log($course->id, 'course', 'view', "view.php?id=$course->id", "$course->id");

    $course->format = clean_param($course->format, PARAM_ALPHA);
    if (!file_exists($CFG->dirroot.'/course/format/'.$course->format.'/format.php')) {
        $course->format = 'weeks';  // Default format is weeks
    }

    $PAGE = page_create_object(PAGE_COURSE_VIEW, $course->id);
    $pageblocks = blocks_setup($PAGE, BLOCKS_PINNED_BOTH);

    if ($reset_user_allowed_editing) {
        // ugly hack
        unset($PAGE->_user_allowed_editing);
    }

    if (!isset($USER->editing)) {
        $USER->editing = 0;
    }
    if ($PAGE->user_allowed_editing()) {
        if (($edit == 1) and confirm_sesskey()) {
            $USER->editing = 1;
        } else if (($edit == 0) and confirm_sesskey()) {
            $USER->editing = 0;
            if(!empty($USER->activitycopy) && $USER->activitycopycourse == $course->id) {
                $USER->activitycopy       = false;
                $USER->activitycopycourse = NULL;
            }
        }

        if ($hide && confirm_sesskey()) {
            set_section_visible($course->id, $hide, '0');
        }

        if ($show && confirm_sesskey()) {
            set_section_visible($course->id, $show, '1');
        }

        if (!empty($section)) {
            if (!empty($move) and confirm_sesskey()) {
                if (!move_section($course, $section, $move)) {
                    notify('An error occurred while moving a section');
                }
            }
        }
    } else {
        $USER->editing = 0;
    }

    $SESSION->fromdiscussion = $CFG->wwwroot .'/course/view.php?id='. $course->id;


    if ($course->id == SITEID) {
        // This course is not a real course.
        redirect($CFG->wwwroot .'/');
    }


    // AJAX-capable course format?
    $useajax = false; 
    $ajaxformatfile = $CFG->dirroot.'/course/format/'.$course->format.'/ajax.php';
    $bodytags = '';

    if (empty($CFG->disablecourseajax) and file_exists($ajaxformatfile)) {      // Needs to exist otherwise no AJAX by default

        // TODO: stop abusing CFG global here
        $CFG->ajaxcapable = false;           // May be overridden later by ajaxformatfile
        $CFG->ajaxtestedbrowsers = array();  // May be overridden later by ajaxformatfile

        require_once($ajaxformatfile);

        if (!empty($USER->editing) && $CFG->ajaxcapable && has_capability('moodle/course:manageactivities', $context)) {
                                                             // Course-based switches

            if (ajaxenabled($CFG->ajaxtestedbrowsers)) {     // Browser, user and site-based switches
                
                require_js(array('yui_yahoo',
                                 'yui_dom',
                                 'yui_event',
                                 'yui_dragdrop',
                                 'yui_connection',
                                 'ajaxcourse_blocks',
                                 'ajaxcourse_sections'));
                
                if (debugging('', DEBUG_DEVELOPER)) {
                    require_js(array('yui_logger'));

                    $bodytags = 'onload = "javascript:
                    show_logger = function() {
                        var logreader = new YAHOO.widget.LogReader();
                        logreader.newestOnTop = false;
                        logreader.setTitle(\'Moodle Debug: YUI Log Console\');
                    };
                    show_logger();
                    "';
                }

                // Okay, global variable alert. VERY UGLY. We need to create
                // this object here before the <blockname>_print_block()
                // function is called, since that function needs to set some
                // stuff in the javascriptportal object.
                $COURSE->javascriptportal = new jsportal();
                $useajax = true;
            }
        }
    }

    $CFG->blocksdrag = $useajax;   // this will add a new class to the header so we can style differently


    $PAGE->print_header(get_string('course').': %fullname%', NULL, '', $bodytags);
    // Course wrapper start.
    echo '<div class="course-content">';
	// ------------------------------------------------------------------------
	global $ac_host;
	$room = $COURSE->idnumber;
	$uid = $USER->idnumber;
	$xsid = acGet_session();
	$oid = acLookup_room($xsid, $room);
	$usid = acGet_sess($uid);
	$data=acRecordlist($usid,$oid);
	
	$dom = new DOMDocument;
	$dom->loadXML($data);
	if (!$dom) {
    	echo 'Fehler beim Parsen des Dokuments';
	    exit;
	}
	$s = simplexml_import_dom($dom);
	
	if ($s->scos[0]->sco)
		{
		$recordingsname =get_string('recordingsname','block_webkonf');
		$recordname = get_string('recordname','block_webkonf');
		$recorddescription = get_string('recorddescription','block_webkonf');
		$recorddate = get_string('recorddate','block_webkonf');
		$recordduration = get_string('recordduration','block_webkonf');
		echo "<br/><h2 class='main'>".$recordingsname."</h2><br/>";
		echo "<br/><table class='groupinfobox'>";
		echo "<tr><td><h3>".$recordname."</h3></td><td><h3>".$recorddescription."</h3></td><td><h3>".$recorddate."</h3></td><td><h3>".$recordduration."</h3></td></tr>";
		foreach ($s->scos[0]->sco as $recording)
			{
			echo "<tr>";
			echo "<td><a href='recording.php?recordid=".preg_replace('{/}', '', $recording->urlpath[0])."&uid=".$USER->idnumber."' target='_blank'>".$recording->name[0]."</a></td>";
			echo "<td>".$recording->description[0]."</td>";
			echo "<td>".substr($recording->datecreated[0],8,2).".".substr($recording->datecreated[0],5,2).".".substr($recording->datecreated[0],0,4)."</td>";
			echo "<td>".substr($recording->duration[0],0,8)."</td>";
			echo "</tr>";
			}
		echo "</table>";
		echo "<p align=\"center\"><a href='javascript:history.back();'>zur&uuml;ck</a></p>";
		}
	else
		{
		$norecordings =get_string('norecordings','block_webkonf');
		echo "<div class=\"box errorbox errorboxcontent\" style=\"background-color:#F5F0EA;color:#E41A32\">";
		echo $norecordings;
		echo "</div>";
		echo "<p align=\"center\"><a href='javascript:history.back();'>zur&uuml;ck</a></p>";
		}

	//-------------------------------------------------------------------------------------
	
    echo "</div>\n\n";


    // Use AJAX?
    if ($useajax && has_capability('moodle/course:manageactivities', $context)) {
        // At the bottom because we want to process sections and activities
        // after the relevant html has been generated. We're forced to do this
        // because of the way in which lib/ajax/ajaxcourse.js is written.
        echo '<script type="text/javascript" ';
        echo "src=\"{$CFG->wwwroot}/lib/ajax/ajaxcourse.js\"></script>\n";

        $COURSE->javascriptportal->print_javascript($course->id);
    }


    print_footer(NULL, $course);

?>
