<?php // $Id: wsdl.php,v 1.1 2008/02/11 08:53:09 winning Exp $

/**
 * This file creates a WSDL file for the web service interfaced running on
 * this server with URL paths relative to the currently running server.
 * 
 * When referring to this file, you must call it as:
 * 
 * http://www.yourhost.com/ ... /ws/wsdl.php
 * 
 * Where ... is the path to your Moodle root.  This is so that your web server
 * will process the PHP statemtents within the file, which returns a WSDL
 * file to the web services call (or your browser).
 * 
 * @version $Id: wsdl.php,v 1.1 2008/02/11 08:53:09 winning Exp $
 * @author Justin Filip <jfilip@oktech.ca>
 * @author Open Knowledge Technologies - http://www.oktech.ca/  
 */


    require_once('../config.php');


    header('Content-Type: application/xml; charset=UTF-8');
    header('Content-Disposition: attachment; filename="moodlews.wsdl"');

    echo '<?xml version="1.0" encoding="UTF-8"?>
<definitions xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:si="http://soapinterop.org/xsd"
  xmlns:tns="' . $CFG->wwwroot . '/ws/wsdl"
  xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
  xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
  xmlns="http://schemas.xmlsoap.org/wsdl/"
  targetNamespace="' . $CFG->wwwroot . '/ws/wsdl">
  <types>
    <xsd:schema targetNamespace="' . $CFG->wwwroot . '/ws/wsdl">
      <xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/" />
      <xsd:import namespace="http://schemas.xmlsoap.org/wsdl/" />
      <xsd:complexType name="getSyncgradeReturn">
        <xsd:all>
          <xsd:element name="id" type="xsd:integer" />
          <xsd:element name="user" type="xsd:string" />
          <xsd:element name="course" type="xsd:string" />
          <xsd:element name="grade" type="xsd:integer" />
          <xsd:element name="gradetime" type="xsd:integer" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="userRecord">
        <xsd:all>
          <xsd:element name="error" type="xsd:string" />
          <xsd:element name="id" type="xsd:integer" />
          <xsd:element name="confirmed" type="xsd:integer" />
          <xsd:element name="policyagreed" type="xsd:integer" />
          <xsd:element name="deleted" type="xsd:integer" />
          <xsd:element name="username" type="xsd:string" />
          <xsd:element name="password" type="xsd:string" />
          <xsd:element name="idnumber" type="xsd:string" />
          <xsd:element name="firstname" type="xsd:string" />
          <xsd:element name="lastname" type="xsd:string" />
          <xsd:element name="email" type="xsd:string" />
          <xsd:element name="icq" type="xsd:string" />
          <xsd:element name="skype" type="xsd:string" />
          <xsd:element name="yahoo" type="xsd:string" />
          <xsd:element name="aim" type="xsd:string" />
          <xsd:element name="msn" type="xsd:string" />
          <xsd:element name="phone1" type="xsd:string" />
          <xsd:element name="phone2" type="xsd:string" />
          <xsd:element name="institution" type="xsd:string" />
          <xsd:element name="department" type="xsd:string" />
          <xsd:element name="address" type="xsd:string" />
          <xsd:element name="city" type="xsd:string" />
          <xsd:element name="country" type="xsd:string" />
          <xsd:element name="lang" type="xsd:string" />
          <xsd:element name="timezone" type="xsd:integer" />
          <xsd:element name="lastip" type="xsd:string" />
          <xsd:element name="description" type="xsd:string" />
		  <xsd:element name="theme" type="xsd:string" />
		  <xsd:element name="emailstop" type="xsd:integer" />
		  <xsd:element name="birthdate" type="xsd:string" />
		  <xsd:element name="company" type="xsd:string" />
          <xsd:element name="customerrole" type="xsd:string" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="userRecords">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="tns:userRecord[]" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="userDatum">
        <xsd:all>
          <xsd:element name="action" type="xsd:string" />
		  <xsd:element name="customerrole" type="xsd:string" />
          <xsd:element name="confirmed" type="xsd:integer" />
          <xsd:element name="policyagreed" type="xsd:integer" />
          <xsd:element name="deleted" type="xsd:integer" />
          <xsd:element name="username" type="xsd:string" />
          <xsd:element name="password" type="xsd:string" />
          <xsd:element name="idnumber" type="xsd:string" />
          <xsd:element name="firstname" type="xsd:string" />
          <xsd:element name="lastname" type="xsd:string" />
          <xsd:element name="email" type="xsd:string" />
          <xsd:element name="icq" type="xsd:string" />
          <xsd:element name="skype" type="xsd:string" />
          <xsd:element name="yahoo" type="xsd:string" />
          <xsd:element name="aim" type="xsd:string" />
          <xsd:element name="msn" type="xsd:string" />
          <xsd:element name="phone1" type="xsd:string" />
          <xsd:element name="phone2" type="xsd:string" />
          <xsd:element name="institution" type="xsd:string" />
          <xsd:element name="department" type="xsd:string" />
          <xsd:element name="address" type="xsd:string" />
          <xsd:element name="city" type="xsd:string" />
          <xsd:element name="country" type="xsd:string" />
          <xsd:element name="lang" type="xsd:string" />
          <xsd:element name="timezone" type="xsd:integer" />
          <xsd:element name="lastip" type="xsd:string" />
          <xsd:element name="description" type="xsd:string" />
		  <xsd:element name="theme" type="xsd:string" />
          <xsd:element name="emailstop" type="xsd:integer" />
		  <xsd:element name="birthdate" type="xsd:string" />
		  <xsd:element name="company" type="xsd:string" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="userData">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="tns:userDatum[]" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="courseRecord">
        <xsd:all>
          <xsd:element name="error" type="xsd:string" />
          <xsd:element name="id" type="xsd:integer" />
          <xsd:element name="category" type="xsd:integer" />
          <xsd:element name="sortorder" type="xsd:integer" />
          <xsd:element name="password" type="xsd:string" />
          <xsd:element name="fullname" type="xsd:string" />
          <xsd:element name="shortname" type="xsd:string" />
          <xsd:element name="idnumber" type="xsd:string" />
          <xsd:element name="summary" type="xsd:string" />
          <xsd:element name="format" type="xsd:string" />
          <xsd:element name="showgrades" type="xsd:integer" />
          <xsd:element name="newsitems" type="xsd:integer" />
          <xsd:element name="teacher" type="xsd:string" />
          <xsd:element name="teachers" type="xsd:string" />
          <xsd:element name="student" type="xsd:string" />
          <xsd:element name="students" type="xsd:string" />
          <xsd:element name="guest" type="xsd:integer" />
          <xsd:element name="startdate" type="xsd:integer" />
          <xsd:element name="enrolperiod" type="xsd:integer" />
          <xsd:element name="numsections" type="xsd:integer" />
          <xsd:element name="marker" type="xsd:integer" />
          <xsd:element name="maxbytes" type="xsd:integer" />
          <xsd:element name="visible" type="xsd:integer" />
          <xsd:element name="hiddensections" type="xsd:integer" />
          <xsd:element name="groupmode" type="xsd:integer" />
          <xsd:element name="groupmodeforce" type="xsd:integer" />
          <xsd:element name="lang" type="xsd:string" />
          <xsd:element name="theme" type="xsd:string" />
          <xsd:element name="cost" type="xsd:string" />
          <xsd:element name="timecreated" type="xsd:integer" />
          <xsd:element name="timemodified" type="xsd:integer" />
          <xsd:element name="metacourse" type="xsd:integer" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="courseRecords">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="tns:courseRecord[]" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="courseDatum">
        <xsd:all>
          <xsd:element name="action" type="xsd:string" />
          <xsd:element name="id" type="xsd:integer" />
          <xsd:element name="category" type="xsd:integer" />
          <xsd:element name="categoryname" type="xsd:string" />
          <xsd:element name="sortorder" type="xsd:integer" />
          <xsd:element name="password" type="xsd:string" />
          <xsd:element name="fullname" type="xsd:string" />
          <xsd:element name="shortname" type="xsd:string" />
          <xsd:element name="idnumber" type="xsd:string" />
          <xsd:element name="summary" type="xsd:string" />
          <xsd:element name="format" type="xsd:string" />
          <xsd:element name="showgrades" type="xsd:integer" />
          <xsd:element name="newsitems" type="xsd:integer" />
          <xsd:element name="teacher" type="xsd:string" />
          <xsd:element name="teachers" type="xsd:string" />
          <xsd:element name="student" type="xsd:string" />
          <xsd:element name="students" type="xsd:string" />
          <xsd:element name="guest" type="xsd:integer" />
          <xsd:element name="startdate" type="xsd:integer" />
          <xsd:element name="enrolperiod" type="xsd:integer" />
          <xsd:element name="numsections" type="xsd:integer" />
          <xsd:element name="marker" type="xsd:integer" />
          <xsd:element name="maxbytes" type="xsd:integer" />
          <xsd:element name="visible" type="xsd:integer" />
          <xsd:element name="hiddensections" type="xsd:integer" />
          <xsd:element name="groupmode" type="xsd:integer" />
          <xsd:element name="groupmodeforce" type="xsd:integer" />
          <xsd:element name="lang" type="xsd:string" />
          <xsd:element name="theme" type="xsd:string" />
          <xsd:element name="cost" type="xsd:string" />
          <xsd:element name="timecreated" type="xsd:integer" />
          <xsd:element name="timemodified" type="xsd:integer" />
          <xsd:element name="metacourse" type="xsd:integer" />
          <xsd:element name="enrollable" type="xsd:integer" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="courseData">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="tns:courseDatum[]" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="gradeRecord">
        <xsd:all>
          <xsd:element name="name" type="xsd:string" />
          <xsd:element name="maxgrade" type="xsd:integer" />
          <xsd:element name="grade" type="xsd:string" />
          <xsd:element name="percent" type="xsd:string" />
          <xsd:element name="weight" type="xsd:float" />
          <xsd:element name="weighted" type="xsd:float" />
          <xsd:element name="sortOrder" type="xsd:integer" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="gradeRecords">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="tns:gradeRecord[]" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="gradeStatsRecord">
        <xsd:all>
          <xsd:element name="gradeItems" type="xsd:integer" />
          <xsd:element name="allgrades" type="xsd:string" />
          <xsd:element name="points" type="xsd:integer" />
          <xsd:element name="totalpoints" type="xsd:integer" />
          <xsd:element name="percent" type="xsd:float" />
          <xsd:element name="weight" type="xsd:float" />
          <xsd:element name="weighted" type="xsd:float" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="studentGradeRecord">
        <xsd:all>
          <xsd:element name="error" type="xsd:string" />
          <xsd:element name="courseid" type="xsd:string" />
          <xsd:element name="stats" type="tns:gradeStatsRecord" />
          <xsd:element name="grades" type="tns:gradeRecords" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="studentGradeRecords">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="tns:studentGradeRecord[]" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="studentRecord">
        <xsd:all>
          <xsd:element name="userid" type="xsd:integer" />
          <xsd:element name="course" type="xsd:integer" />
          <xsd:element name="timestart" type="xsd:integer" />
          <xsd:element name="timeend" type="xsd:integer" />
          <xsd:element name="timeaccess" type="xsd:integer" />
          <xsd:element name="enrol" type="xsd:string" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="studentRecords">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="tns:studentRecord[]" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="loginReturn">
        <xsd:all>
          <xsd:element name="client" type="xsd:integer" />
          <xsd:element name="sessionkey" type="xsd:string" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="editUserInput">
        <xsd:all>
          <xsd:element name="users" type="tns:userData" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="editUserOutput">
        <xsd:all>
          <xsd:element name="users" type="tns:userRecords" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="getUserInput">
        <xsd:sequence>
          <xsd:element name="userid" type="xsd:string"
           minOccurs="0" maxOccurs="unbounded" />
        </xsd:sequence>
      </xsd:complexType>
      <xsd:complexType name="getUserReturn">
        <xsd:all>
          <xsd:element name="users" type="tns:userRecords" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="editCourseInput">
        <xsd:all>
          <xsd:element name="courses" type="tns:courseData" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="editCourseOutput">
        <xsd:all>
          <xsd:element name="courses" type="tns:courseRecords" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="getCourseInput">
        <xsd:sequence>
          <xsd:element name="courseid" type="xsd:string"
           minOccurs="0" maxOccurs="unbounded" />
        </xsd:sequence>
      </xsd:complexType>
      <xsd:complexType name="getCourseReturn">
        <xsd:all>
          <xsd:element name="courses" type="tns:courseRecords" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="getGradesInput">
        <xsd:sequence>
          <xsd:element name="userid" type="xsd:string"
           minOccurs="0" maxOccurs="unbounded" />
        </xsd:sequence>
      </xsd:complexType>
      <xsd:complexType name="getGradesReturn">
        <xsd:all>
          <xsd:element name="grades" type="tns:studentGradeRecords" />
        </xsd:all>
      </xsd:complexType>
      <xsd:complexType name="enrolStudentsInput">
        <xsd:sequence>
          <xsd:element name="userid" type="xsd:string"
           minOccurs="0" maxOccurs="unbounded" />
        </xsd:sequence>
      </xsd:complexType>
<xsd:complexType name="unenrolStudentsInput">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="xsd:string" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="enrolStudentsReturn">
        <xsd:all>
          <xsd:element name="error" type="xsd:string" />
          <xsd:element name="students" type="tns:studentRecords" />
        </xsd:all>
      </xsd:complexType>
    </xsd:schema>
     <xsd:complexType name="enrolInput">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="xsd:string" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
      <xsd:complexType name="unenrolInput">
        <xsd:complexContent>
          <xsd:restriction base="SOAP-ENC:Array">
            <xsd:attribute ref="SOAP-ENC:arrayType"
              wsdl:arrayType="xsd:string" />
          </xsd:restriction>
        </xsd:complexContent>
      </xsd:complexType>
  </types>
  <message name="mdl_soapserver.get_syncgradeRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.get_syncgradeResponse">
    <part name="return" type="tns:getSyncgradeReturn" />
  </message>		
  <message name="mdl_soapserver.del_syncgradeRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="id" type="xsd:integer" />
  </message>
  <message name="mdl_soapserver.del_syncgradeResponse">
    <part name="return" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.loginRequest">
    <part name="username" type="xsd:string" />
    <part name="password" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.loginResponse">
    <part name="return" type="tns:loginReturn" />
  </message>
  <message name="mdl_soapserver.logoutRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.logoutResponse">
    <part name="return" type="xsd:boolean" />
  </message>
  <message name="mdl_soapserver.edit_userRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="users" type="tns:editUserInput" />
  </message>
  <message name="mdl_soapserver.edit_userResponse">
    <part name="return" type="tns:editUserOutput" />
  </message>
  <message name="mdl_soapserver.get_userRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="userids" type="tns:getUserInput" />
    <part name="idfield" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.get_userResponse">
    <part name="return" type="tns:getUserReturn" />
  </message>
  <message name="mdl_soapserver.edit_courseRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courses" type="tns:editCourseInput" />
  </message>
  <message name="mdl_soapserver.edit_courseResponse">
    <part name="return" type="tns:editCourseOutput" />
  </message>
  <message name="mdl_soapserver.get_courseRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseids" type="tns:getCourseInput" />
    <part name="idfield" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.get_courseResponse">
    <part name="return" type="tns:getCourseReturn" />
  </message>
  <message name="mdl_soapserver.get_gradesRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="userid" type="xsd:string" />
    <part name="courseids" type="tns:getGradesInput" />
    <part name="idfield" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.get_gradesResponse">
    <part name="return" type="tns:getGradesReturn" />
  </message>
  <message name="mdl_soapserver.enrol_studentsRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseid" type="xsd:string" />
    <part name="userids" type="tns:enrolStudentsInput" />
    <part name="idfield" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.enrol_studentsResponse">
    <part name="return" type="tns:enrolStudentsReturn" />
  </message>
  <message name="mdl_soapserver.enrolRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseid" type="xsd:string" />
    <part name="userids" type="tns:enrolStudentsInput" />
    <part name="roleid" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.enrolResponse">
    <part name="return" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.unenrolRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseid" type="xsd:string" />
    <part name="userids" type="tns:unenrolStudentsInput" />
  </message>
  <message name="mdl_soapserver.unenrolResponse">
    <part name="return" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.import_backupRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseid" type="xsd:string" />
    <part name="file" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.import_backupResponse">
    <part name="return" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.add_to_metacourseRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseid1" type="xsd:string" />
    <part name="courseid2" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.add_to_metacourseResponse">
    <part name="return" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.add_resource_linkRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseid" type="xsd:string" />
    <part name="url" type="xsd:string" />
    <part name="name" type="xsd:string" />
    <part name="summary" type="xsd:string" />
    <part name="type" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.add_resource_linkResponse">
    <part name="return" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.update_resource_linkRequest">
    <part name="client" type="xsd:integer" />
    <part name="sesskey" type="xsd:string" />
    <part name="courseid" type="xsd:string" />
    <part name="url" type="xsd:string" />
    <part name="name" type="xsd:string" />
    <part name="summary" type="xsd:string" />
    <part name="type" type="xsd:string" />
    <part name="rname" type="xsd:string" />
  </message>
  <message name="mdl_soapserver.update_resource_linkResponse">
    <part name="return" type="xsd:string" />
  </message>
  <portType name="MoodleWSPortType">
    <operation name="mdl_soapserver.get_syncgrade">
      <documentation>MoodleWS Get Syncgrade</documentation>
      <input message="tns:mdl_soapserver.get_syncgradeRequest" />
      <output message="tns:mdl_soapserver.get_syncgradeResponse" />
    </operation>   
    <operation name="mdl_soapserver.del_syncgrade">
      <documentation>MoodleWS Del Syncgrade</documentation>
      <input message="tns:mdl_soapserver.del_syncgradeRequest" />
      <output message="tns:mdl_soapserver.del_syncgradeResponse" />
    </operation>
    <operation name="mdl_soapserver.login">
      <documentation>MoodleWS Client Login</documentation>
      <input message="tns:mdl_soapserver.loginRequest" />
      <output message="tns:mdl_soapserver.loginResponse" />
    </operation>
    <operation name="mdl_soapserver.logout">
      <documentation>MoodleWS: Client Logout</documentation>
      <input message="tns:mdl_soapserver.logoutRequest" />
      <output message="tns:mdl_soapserver.logoutResponse" />
    </operation>
    <operation name="mdl_soapserver.edit_user">
      <documentation>MoodleWS: Edit User Information</documentation>
      <input message="tns:mdl_soapserver.edit_userRequest" />
      <output message="tns:mdl_soapserver.edit_userResponse" />
    </operation>
    <operation name="mdl_soapserver.get_user">
      <documentation>MoodleWS: Get User Information</documentation>
      <input message="tns:mdl_soapserver.get_userRequest" />
      <output message="tns:mdl_soapserver.get_userResponse" />
    </operation>
    <operation name="mdl_soapserver.edit_course">
      <documentation>MoodleWS: Edit Course Information</documentation>
      <input message="tns:mdl_soapserver.edit_courseRequest" />
      <output message="tns:mdl_soapserver.edit_courseResponse" />
    </operation>
    <operation name="mdl_soapserver.get_course">
      <documentation>MoodleWS: Get Course Information</documentation>
      <input message="tns:mdl_soapserver.get_courseRequest" />
      <output message="tns:mdl_soapserver.get_courseResponse" />
    </operation>
    <operation name="mdl_soapserver.get_grades">
      <documentation>MoodleWS: Get User Grades</documentation>
      <input message="tns:mdl_soapserver.get_gradesRequest" />
      <output message="tns:mdl_soapserver.get_gradesResponse" />
    </operation>
    <operation name="mdl_soapserver.enrol_students">
      <documentation>
        MoodleWS: Enrol students in a course
      </documentation>
      <input message="tns:mdl_soapserver.enrol_studentsRequest" />
      <output message="tns:mdl_soapserver.enrol_studentsResponse" />
    </operation>
 <operation name="mdl_soapserver.enrol">
      <documentation>
        MoodleWS: Enrol users with role in a course
      </documentation>
      <input message="tns:mdl_soapserver.enrolRequest" />
      <output message="tns:mdl_soapserver.enrolResponse" />
    </operation>
    <operation name="mdl_soapserver.unenrol">
      <documentation>
        MoodleWS: Unenrol users from a course
      </documentation>
      <input message="tns:mdl_soapserver.unenrolRequest" />
      <output message="tns:mdl_soapserver.unenrolResponse" />
    </operation>
    <operation name="mdl_soapserver.import_backup">
      <documentation>
        MoodleWS: import course backup
      </documentation>
      <input message="tns:mdl_soapserver.import_backupRequest" />
      <output message="tns:mdl_soapserver.import_backupResponse" />
    </operation>
    <operation name="mdl_soapserver.add_to_metacourse">
      <documentation>
        MoodleWS: add course / meta course connection
      </documentation>
      <input message="tns:mdl_soapserver.add_to_metacourseRequest" />
      <output message="tns:mdl_soapserver.add_to_metacourseResponse" />
    </operation>
    <operation name="mdl_soapserver.add_resource_link">
      <documentation>
        MoodleWS: add resource link to course
      </documentation>
      <input message="tns:mdl_soapserver.add_resource_linkRequest" />
      <output message="tns:mdl_soapserver.add_resource_linkResponse" />
    </operation>
    <operation name="mdl_soapserver.update_resource_link">
      <documentation>
        MoodleWS: update resource link in course
      </documentation>
      <input message="tns:mdl_soapserver.update_resource_linkRequest" />
      <output message="tns:mdl_soapserver.update_resource_linkResponse" />
    </operation>
  </portType>
  <binding name="MoodleWSBinding" type="tns:MoodleWSPortType">
    <soap:binding style="rpc"
      transport="http://schemas.xmlsoap.org/soap/http" />
    <operation name="mdl_soapserver.get_syncgrade">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#get_syncgrade"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.del_syncgrade">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#del_syncgrade"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>	  
    <operation name="mdl_soapserver.login">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#login"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.logout">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#logout"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.edit_user">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#edit_user"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.get_user">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#get_user"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.edit_course">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#edit_course"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.get_course">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#get_course"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.get_grades">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#get_grades"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.enrol_students">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#enrol_students"
        style="rpc" />
      <input>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="literal"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
  <operation name="mdl_soapserver.enrol">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#enrol"
        style="rpc" />
      <input>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.unenrol">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#unenrol"
        style="rpc" />
      <input>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.import_backup">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#import_backup"
        style="rpc" />
      <input>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.add_to_metacourse">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#add_to_metacourse"
        style="rpc" />
      <input>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.add_resource_link">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#add_resource_link"
        style="rpc" />
      <input>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="mdl_soapserver.update_resource_link">
      <soap:operation
        soapAction="' . $CFG->wwwroot . '/ws/wsdl#update_resource_link"
        style="rpc" />
      <input>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded"
          namespace="' . $CFG->wwwroot . '/ws/wsdl"
          encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
  </binding>
  <service name="MoodleWS">
    <port name="MoodleWSPort" binding="tns:MoodleWSBinding">
      <soap:address
        location="' . $CFG->wwwroot . '/ws/service.php?type=soap" />
    </port>
  </service>
</definitions>';

?>
